#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <bits/stdc++.h>

using namespace std;

void plazmanjavanje(vector <bool>& plazmice, int d, int p){
    d=d-1;
    int kraj=d+p;
    if(kraj>300000){
        fill(plazmice.begin() + d, plazmice.end(), 1);
    }
    else{
        fill(plazmice.begin() + d, plazmice.begin()+kraj, 1);
    }
    /*while(p){
        plazmice[d++]=1;
        p--;
    }*/
}

int gladnaovacerka(vector <bool> plazmice, int d){
    int br=0;
    for(int i=0;i<d;i++){
        if(plazmice[i]){
            br++;
        }
    }
    return br;
}

int main()
{
    vector <bool> PLAZMA(300000,0);
    ios_base::sync_with_stdio(false);
    int n,q,d,p,k;
    cin >> n >> q;
    for(int i=0;i<n;i++){
        cin >> d >> p;
        plazmanjavanje(PLAZMA,d,p);
    }
    for(int j=0;j<q;j++){
        cin >> k;
        cout << gladnaovacerka(PLAZMA,k) << "\n";
    }
    return 0;
}